// date1.cpp
// member function definitions for date1 class
// last date : 23 Aug 98
#include<iostream.h>
#include"date1.h"

//initialize static members
//since arrays start at zero, the first number is 0 which
//is not used.
int Date::days[] = {0,31,28,31,30,31,30,31,31,30,31,30,31};

//Date constructor accepting 3 arguments
Date::Date(int d, int m, int y)
{getDate(d, m, y);}

//Date destructor
Date::~Date()
{cout << "This is where the class Date destructor occurs\n"; }

int Date::caldays()
{
int firstdays=0;
for(int countyear=1900;countyear<_year;countyear++)
   {if(countyear%4 == 0 && (countyear % 400 == 0 || countyear % 100 != 0))
       firstdays += 366;
    else
       firstdays += 365;
    }
cout << "total days " << firstdays;
return firstdays ;
}

//member function definition to display the date
void Date::getDate(int d1, int m1, int y1 )
{
 // ensure value of month is between 1 and 12
 _mth = (m1 >= 1 && m1 <= 12) ? m1 : 1;
 // ensure value of year is between 1900 and 2100
 _year =(y1 >= 1900 && y1 <= 2100) ? y1 : 1900;
 // test for leap year
 if(_mth == 2 && _year % 4 == 0 && (_year % 400 == 0 || _year % 100 != 0))
   _day=(d1 >= 1 && d1 <= 29) ? d1 : 1;
 else
   _day=(d1 >= 1 && d1 <= days[_mth]) ? d1 : 1;
}


//member function of Date to display the dates
void Date::display()
{char dummy;
 char validday;
 int totaldays;
 totaldays=0;
 totaldays=caldays(); // zero is Monday, one is Tues and etc
 for(_mth = 1; _mth <= 12; _mth++)
  {
   validday = 'y';
   dispMonth(_mth);
   _day = 1;
   cout << ", " << _year << "\n";
   cout << "Sun\tMon\tTue\tWed\tThu\tFri\tSat\n";
   for(int i = 0; i <= ((totaldays % 7 ) == 6 ? -1 : totaldays%7 ); i++)
      cout << "\t";
   while(validday != 'n')
   {
     cout << _day ;
     totaldays++;
     //increment the days by one
     _day++ ;
     if((totaldays % 7)==6)
       cout << "\n";
     else
       cout << "\t";

     // test for leap year
     if(_mth == 2 && _year % 4 == 0 && (_year % 400 == 0 || _year % 100 != 0))
       {if( _day > 29 )
         validday = 'n';     //it is a leap year
       }
     else if( _day > days[_mth] )
            validday = 'n'; //it is not aleap year
     }
    cout << "\nTotal days: " << totaldays <<
        " Press [x] and enter key to continue :";
    cin >> dummy;
   }
}

//function to determine wordings of the month to be displayed
void dispMonth(int validmonth)
{
 static char *monthName[13] = {"", "January",
  "February", "March", "April", "May", "June", "July", "August",
  "September", "October", "November", "December"};
  cout << "\n" << monthName[validmonth] ;
}
